#include <iostream>
// Import hlavikovho sboru rozhrania OpenMP.
#include <omp.h>
#include <windows.h>

using namespace std;

int wmain()
{
    double krok, x, obsah = 0.0; 
    long int i, pocetKrokov = 1000000000;
    unsigned int cas0, casN;
    krok = 1.0 / pocetKrokov;

	for(int pocetRelacii = 1; pocetRelacii <= 5; pocetRelacii++)
    {
        x = obsah = 0.0;
        cas0 = GetTickCount();
        cout << "Vypocet c. " << pocetRelacii << " sa zacal." << endl;
 
		// Paraleln algoritmus numerickej integrcie.
        #pragma omp parallel for reduction(+: obsah) private(x)
        for(i = 0; i < pocetKrokov; i++)
        {
            x = i * krok;
            obsah += 4.0 / (1.0 + x * x);
        }

		casN = GetTickCount();
        cout << "Vypocet c. " << pocetRelacii << " sa skoncil." << endl;
        cout.precision(20);
        cout << "Vystup: " << obsah * krok << "." << endl;
        cout << "Exekucny cas: " << casN - cas0 << " ms." << endl << endl;
    }

	cout << "Paralelna numericka integracia je hotova." << endl;
	return 0;
}
