#include <iostream>
#include <cmath>
#include <windows.h>
#include <ppl.h>

using namespace std;
using namespace Concurrency;

bool Test(int cislo);

int wmain()
{
    int hornaHranica = 10000000; long pocetPrvocisel = 0;
    unsigned int cas0, casN;
	
	cout << "Prebieha paralelne vyhladavanie prvocisel..." << endl;
    cas0 = GetTickCount();
    // Paraleln vyhadvanie prvosel uskutouje paraleln cyklus for.
    parallel_for(2, hornaHranica + 1, [&pocetPrvocisel](int i)
    {
        if (Test(i)) 
            InterlockedIncrement(&pocetPrvocisel);
    });

    cout << "Paralelne vyhladavanie prvocisel sa skoncilo." << endl;
    casN = GetTickCount();
    cout << "V intervale <2, " << hornaHranica << "> je " << pocetPrvocisel <<
        " prvocisel." << endl;
    cout << "Cas spracovania: " << casN - cas0 << " ms." << endl; 
    return 0;
}

// Funkcia, ktor uskutouje test prvoselnosti. 
bool Test(int cislo)
{
    int odmocninaZCisla = (int)sqrt((float)cislo);
    for (int i = 2; i <= odmocninaZCisla; i++)
    {
        if (cislo % i == 0) return false;
    }
    return true;
}
